import '../../App.css'
import {
  Skeleton, Box, IconButton, TableCell, TableContainer,
  Table, TableRow, Paper, TableBody
} from '@mui/material';

import { Col, Row } from 'react-bootstrap'

import React from 'react'

import {
  CheckBox as CheckBoxIcon,
  FmdBad as FmdBadIcon,
  NewReleases as NewReleasesIcon
} from '@mui/icons-material'


const big_as = 70

function Asignaciones(props) {
  let { asign } = props;
  let { cattest } = asign;
  return (
    <tr>
      <td>
        {cattest.decription}
        <IconButton color="primary" aria-label="puesto_status" components="label">
          <CheckBoxIcon />
        </IconButton>
      </td>
    </tr>
  )
}

function TableUser(props) {
  let { user } = props;
  let { asignaciones, candi } = user

  if (asignaciones.lenght <= 0) {
    return <h1>Sin datos</h1>
  }

  return (
    <TableRow >
      <TableCell
        style={{ borderRight: '1px solid #f1f1f1 !important' }}
        className="home_letter pwd_user_name ">
        {candi.nombre + " " + candi.apellidos}
      </TableCell>
      <TableCell className="table_list_test_user home_letter">
        <table>
          <tbody >
            {
              asignaciones?.length > 0 ?
                asignaciones.map(a => <Asignaciones key={a.id} asign={a} />)
                : <SinAsignaciones />
            }
          </tbody>
        </table>
      </TableCell>
    </TableRow>
  )
}

function SinAsignaciones() {
  return (
    <tr style={{ padding: 5 }}>
      <center className="home_letter">
        <i> El candidato aun no cuenta con asignaciones... </i>
        <FmdBadIcon style={{ color: 'var(--main)' }} />
      </center>
    </tr>
  )
}

export function Candidato(props) {
  let { password, candidatos } = props.user

  return (
    <div className="data_candidato">
      <Row>
        <Col md="3" sm="12" style={{ padding: 10, borderRight: '1px solid #f1f1f1' }}>
          <p><b>{password?.toUpperCase()}</b></p>
        </Col>
        <Col md="9">
          <TableContainer style={{ boxShadow: "none" }} component={Paper}>
            <Table size="small" aria-label="a dense table">
              <TableBody>
                {
                  candidatos.length > 0 ?
                    candidatos.map(u => <TableUser key={u.candi.id} user={u} />)
                    : <SinAsignRealizadas />

                }
              </TableBody>
            </Table>
          </TableContainer>
        </Col>
      </Row>
    </div>
  )
}

function SinAsignRealizadas() {
  return (
    <div style={{ padding: 5 }}>
      <center className="home_letter">
        <i> No se ha relizado ninguna asignacion... </i>
        <NewReleasesIcon style={{ color: '#e8eb34' }} />
      </center>
    </div>
  )
}

export function Preview() {
  return (
    <Box sx={{ width: '100%' }}>
      <Skeleton height={big_as} animation="wave" />
      <Skeleton height={big_as} animation="wave" />
      <Skeleton height={big_as} animation="wave" />
      <Skeleton height={big_as} animation="wave" />
      <Skeleton height={big_as} animation="wave" />
    </Box>
  )
}
